std::basic_string::rend,(3)

NAME
std::basic_string::rend, - std::basic_string::rend,

Synopsis
   reverse_iterator rend(); (until C++11)
   reverse_iterator rend() noexcept; (since C++11)
                        (until C++20)
   constexpr reverse_iterator rend() noexcept; (since C++20)
   const_reverse_iterator rend() const; (until
                        C++11)
                        (since
   const_reverse_iterator rend() const noexcept; C++11)
                        (1) (until
                        C++20)
   constexpr const_reverse_iterator rend() const (2) (since
   noexcept; C++20)
                        (since
   const_reverse_iterator crend() const noexcept; C++11)
                        (3) (until
                        C++20)
   constexpr const_reverse_iterator crend() const (since
   noexcept; C++20)
   Returns a reverse iterator to the character following the last character of the
   reversed string. It corresponds to the character preceding the first character of
   the non-reversed string. This character acts as a placeholder, attempting to access
   it results in undefined behavior.
   range-rbegin-rend.svg

Parameters
   (none)

Return value
   reverse iterator to the character following the last character

Complexity
   Constant

Example
// Run this code
 #include <algorithm>
 #include <iostream>
 #include <iterator>
 #include <string>
 int main()
 {
   std::string s("A man, a plan, a canal: Panama");
   {
     std::string c;
     std::copy(s.rbegin(), s.rend(), std::back_inserter(c));
     std::cout << c <<'\n'; // "amanaP :lanac a ,nalp a ,nam A"
   }
   {
     std::string c;
     std::copy(s.crbegin(), s.crend(), std::back_inserter(c));
     std::cout << c <<'\n'; // "amanaP :lanac a ,nalp a ,nam A"
   }
 }

Output:
 amanaP :lanac a ,nalp a ,nam A
 amanaP :lanac a ,nalp a ,nam A

See also
   rbegin returns a reverse iterator to the beginning
   crbegin (public member function)
   (C++11)
   rend returns a reverse iterator to the end
   crend (public member function of std::basic_string_view<CharT,Traits>)
   (C++17)